<package xmlNamespace="" packageName="net.ihe.gazelle.hpd.validator.chcpi" standards="">
		<name>chcpi</name>
		<description></description>
  			<ConstraintsSpec>
  						<name>SubstringFilterSpec</name>
  						<xmlName>SubstringFilterSpec</xmlName>
  						<parentId>core-SubstringFilter</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_attr_substr</name>
  							<description>The defined attributes for the CHCommunity and CHEndpoint object classes are listed in Appendix B. LDAP Schema Overview</description>
  							<ocl>not(self.name.oclIsUndefined()) 
  			and(
  			          self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.2&#039;, self.name.toLowerCase())
  			          or self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.3&#039;, self.name.toLowerCase())
  			          )
  			                      </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-003" idScheme="CH-CPI"/>
  								<assertion assertionId="CH-CPI-005" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
  			<ConstraintsSpec>
  						<name>AttributeDescriptionSpec</name>
  						<xmlName>AttributeDescriptionSpec</xmlName>
  						<parentId>core-AttributeDescription</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_attr_attrdesc</name>
  							<description>The defined attributes for the CHCommunity ad CHEndpoint object classes are listed in Appendix B. LDAP Schema Overview</description>
  							<ocl>not(self.name.oclIsUndefined()) 
  			and(
  			          self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.2&#039;, self.name.toLowerCase())
  			          or self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.3&#039;, self.name.toLowerCase())
  			          )
  			                      </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-003" idScheme="CH-CPI"/>
  								<assertion assertionId="CH-CPI-005" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
  			<ConstraintsSpec>
  						<name>BatchRequestSpec</name>
  						<xmlName>BatchRequestSpec</xmlName>
  						<parentId>core-BatchRequest</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_001</name>
  							<description>The only DSML element supported is the “searchRequest” element</description>
  							<ocl>self.abandonRequest-&gt;size()=0 and
  			                          self.addRequest-&gt;size()=0 and
  			                          self.compareRequest-&gt; size()=0 and
  			                          self.delRequest-&gt;size()=0 and
  			                          self.extendedRequest-&gt;size()=0 and
  			                          self.modDNRequest-&gt;size()=0 and
  			                          self.modifyRequest-&gt;size()=0
  			                      </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-001" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
  			<ConstraintsSpec>
  						<name>SearchRequestSpec</name>
  						<xmlName>SearchRequestSpec</xmlName>
  						<parentId>core-SearchRequest</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_006</name>
  							<description>Each community of object class “CHCommunity” has attributes that reference the corresponding gateway, assertion provider or authorization decision elements in the organisational unit “CHEndpoint”.
  			Furthermore, each gateway element is prefixed with the shcIssuerName of its community.</description>
  							<ocl>self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;^uid=.+:.+&#039;) implies (
  			self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;.*ou=chcommunity,dc=cpi.*&#039;) and
  			CommonOperationsStatic::matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.7&#039;, self.dn.oclAsType(String).toLowerCase().substring(self.dn.oclAsType(String).indexOf(&#039;:&#039;) + 1, self.dn.oclAsType(String).indexOf(&#039;,&#039;) - 1))
  			)
  			</ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-006" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  						<constraint>
  							<name>constraint_ch_cpi_002</name>
  							<description>The searchRequest is supported on the CPI root or one of its child elements: ou=CHCommunity or ou=CHEndpoint.</description>
  							<ocl>self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;.*ou=chcommunity,dc=cpi.*&#039;) 
  			or  self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;.*ou=chendpoint,dc=cpi.*&#039;) 
  			or self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;.*dc=cpi.*&#039;) 
  			              </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-002" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  						<constraint>
  							<name>constraint_ch_cpi_004</name>
  							<description>The CPI base distinguished name / directory root is dc=CPI,o=BAG,c=CH.</description>
  							<ocl>self.matches(self.dn.oclAsType(String).toLowerCase(),&#039;.*,dc=cpi,o=bag,c=ch&#039;)</ocl>
  							<type>org.eclipse.emf.ecore.impl.DynamicEObjectImpl@5b02a984 (eClass: org.eclipse.emf.ecore.impl.EClassImpl@57186526 (name: OclInvalid_Class) (instanceClassName: null) (abstract: false, interface: false))</type>
  							
  							<assertion assertionId="CH-CPI-004" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
  			<ConstraintsSpec>
  						<name>AttributeValueAssertionSpec</name>
  						<xmlName>AttributeValueAssertionSpec</xmlName>
  						<parentId>core-AttributeValueAssertion</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_attr_valassert</name>
  							<description>The defined attributes for the CHCommunity and CHEndpoint object classes are listed in Appendix B. LDAP Schema Overview</description>
  							<ocl>not(self.name.oclIsUndefined()) 
  			and(
  			          self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.2&#039;, self.name.toLowerCase())
  			          or self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.3&#039;, self.name.toLowerCase())
  			          )
  			                      </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-003" idScheme="CH-CPI"/>
  								<assertion assertionId="CH-CPI-005" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
  			<ConstraintsSpec>
  						<name>MatchingRuleAssertionSpec</name>
  						<xmlName>MatchingRuleAssertionSpec</xmlName>
  						<parentId>core-MatchingRuleAssertion</parentId>
  						<constraint>
  							<name>constraint_ch_cpi_attr_mathingrule</name>
  							<description>The defined attributes for the CHCommunity and CHEndpoint object classes are listed in Appendix B. LDAP Schema Overview</description>
  							<ocl>not(self.name.oclIsUndefined()) 
  			and(
  			          self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.2&#039;, self.name.toLowerCase())
  			          or self.matchesCodeToValueSet(&#039;1.3.6.1.4.1.12559.11.25.1.15.3&#039;, self.name.toLowerCase())
  			          )
  			                      </ocl>
  							<type>ERROR</type>
  							
  							<assertion assertionId="CH-CPI-003" idScheme="CH-CPI"/>
  								<assertion assertionId="CH-CPI-005" idScheme="CH-CPI"/>
  							
  							
  							
  							
  							
  						</constraint>
  					</ConstraintsSpec>
	</package>

